/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.email.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.email.entity.EmailVorgang;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractEmailVorgangSearch {

  @Inject
  protected transient EmailVorgangExtendedDAO dao;

  public AbstractEmailVorgangSearch() {
    super();
  }

  public List<EmailVorgang> getSearchResult(EmailVorgangSearchParameters searchParameters, EagerLoadingCollector<EmailVorgang> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<EmailVorgang> querySearchResult(EmailVorgangSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
